SystemOrganization addCategory: #'PEGWiki-Core'!

!ALAjaxCounterComponent class methodsFor: '*pegwiki-core' stamp: 'chc 12/29/2015 15:23'!
wikiString: anObject
	^self basicNew
		intializeWithWikiString: anObject;
		yourself! !

!ALAjaxCounterComponent methodsFor: '*pegwiki-core' stamp: 'chc 12/29/2015 15:19'!
intializeWithWikiString: anObject
	count := anObject! !

!ALAjaxCounterComponent methodsFor: '*pegwiki-core' stamp: 'chc 12/29/2015 15:10'!
renderOn: json
	json object:
		[json name: 'count' value: count.
		"json name: 'dec' navigate: [count := count - 1].
		json name: 'inc' navigate: [count := count + 1]"]! !

!ALAjaxCounterComponent methodsFor: '*pegwiki-core' stamp: 'chc 12/29/2015 15:10'!
wikiString: anObject
	count := anObject! !

Object subclass: #PEGWiki
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PEGWiki-Core'!

!PEGWiki commentStamp: 'chc 3/22/2016 09:27' prior: 0!
Start PEGWiki with: 

PEGWiki start 

This depends on the PWModelConfiguration singleton being populated so that requests like 

PWModelConfiguration instance valueAt: #port

return values. !

!PEGWiki class methodsFor: 'as yet unclassified' stamp: 'chc 3/24/2016 09:52'!
start
"use this to start the app"
	| authenticator app | 
	authenticator := ALMemoryAuthenticator new. 
	authenticator register: 'chriscunnington'
 					username: (PWSeasidePrefsModel instance valueAt: #username)
 					password: (PWSeasidePrefsModel instance valueAt: #password).

	app := ALExampleApplication new.
	app addFactory: [:term | ALAuthenticationRelay destination: term
						authenticator: authenticator 
						shunt: nil].
	(ALServer on: (PWSeasidePrefsModel instance valueAt: #port) application: app) start 

! !

ALExample subclass: #ALAsyncExample
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PEGWiki-Core'!

!ALAsyncExample methodsFor: 'as yet unclassified' stamp: 'chc 3/24/2016 09:39'!
renderContentOn: html
	html span
		class: 'counter';
		id: 'count';
		with: '0'.
((PWSeasidePrefsModel instance valueAt: #render) = 'on') ifTrue: [
	html form id: 'myform'; beMethodPost; with:
		[html textarea name: 'wikiString'; with: [ html text: (PWSeasidePrefsModel instance valueAt: #currentString)].
		 html br. 
		 html input beTypeSubmit ]]. 
	self renderScriptsOn: html! !

!ALAsyncExample methodsFor: 'as yet unclassified' stamp: 'chc 1/11/2016 12:51'!
renderScriptsOn: html
	html script src: 'https://ajax.googleapis.com/ajax/libs/jquery/1.7.2/jquery.min.js'.
	html script src: 'http://localhost:8624/jquery.form.js'.
	html script
		type: 'application/javascript';
		with: [html raw: self libraryScript].
	html script 
		type: 'application/javascript';
		with: [self renderFormScriptOn: html].
	html script
		type: 'application/javascript';
		with: [self renderInitScriptOn: html]! !

ALAsyncExample subclass: #PWConfigPage
	instanceVariableNames: 'integer something'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PEGWiki-Core'!

!PWConfigPage commentStamp: 'chc 3/22/2016 09:28' prior: 0!
This is a config page at /config like Seaside. It's a panel for adding tools. !

!PWConfigPage methodsFor: 'as yet unclassified' stamp: 'chc 1/7/2016 18:45'!
initialize
	integer := 'off'.
	something := 'Coco Beware'! !

!PWConfigPage methodsFor: 'as yet unclassified' stamp: 'chc 2/1/2016 13:50'!
renderAttribute: anAttribute on: anHtmlCanvas

	! !

!PWConfigPage methodsFor: 'as yet unclassified' stamp: 'chc 3/24/2016 09:36'!
renderContentOn: html
	html form beMethodGet; with:
		[ html p: 'Show wiki syntax form for editing page content: '.
			html input 
			beTypeRadio;
			value: 'on';
			callback: [:str | PWSeasidePrefsModel instance takeValue: str forAttribute: (WAStringAttribute key: #render group: #wikidata). ];
			with: [html text: 'On'].
		html br. 
		html input beTypeRadio;
			value: 'off';
			callback: [:str | PWSeasidePrefsModel instance takeValue: str forAttribute: (WAStringAttribute key: #render group: #wikidata). ];
			with: [html text: 'Off'].
		html br.
		html input beTypeSubmit; value: 'Save'.
		html br.
		html text: (PWSeasidePrefsModel instance valueAt: #render) ].
	
		html table with: [ 
			PWSeasidePrefsModel instance groupedAttributes do: [:association| 
					html tr with: [
						html td colspan: '2'; with: [ html h3: (self labelForSelector: association key).
							association value do: [ :attribute |
								self renderAttribute: attribute on: html ]
				 			]]]].
		html br.
		html table
			with: [html tr
				with: [html td with: 'Port'.
					html td with: '8624']].
		html textarea.
		html form beMethodGet; with:
		[html input 
			beTypeText
			value: integer printString;
			size: '100';
			callback: [:str | Compiler evaluate: str unescapePercents "integer := str ""asNumber"];
			with: [].
		html text: integer "asWords"].
		self renderStyleOn: html.
		
		
		
		! !

!PWConfigPage methodsFor: 'as yet unclassified' stamp: 'chc 1/28/2016 12:32'!
renderStyleOn: html
	^ html style: '
			table, tr, td {border: 1px solid green;}'! !

!ALExampleApplication methodsFor: '*pegwiki-core' stamp: 'chc 1/20/2016 00:42'!
initializeLocator
	locator 
		at: ALPath root 
		put: ALExamplePage new asResource.
	locator 
		at: ALPath root / 'config'
		put: (PWBasicAuthResource component: (PWConfigPage new)).
	"locator at: (ALPath / 'jquery.form.js')
		put: (ALFileResource on: (FSLocator imageDirectory / 'jquery.form.js') resolve)."! !
